help_version::"0.02", help_date::"29.01.2005";

helptext :: |"\
**esl on one screen**: Semikola trennen \"evaluation units\", daher Eingaben
mit \";\" beenden. Ein evaluation-unit kann aus mehreren Teilen bestehen, durch
Kommas getrennt; diese Teile werden nacheinander evaluiert, die Ergebnisse als
Liste ausgegeben. - Operatoren sind u.a. ^ (Potenz), ! (Postfix, Fakultaet), *,
/, div, mod, ++, -- (wie in C), +, -, <, <=, =, >, >=, not, and, or (mit abneh-
mender Prioritaet). Funktionen u.a. abs, exp, sin, cos, tan, atan, sqrt, cons,
first, rest. - Control-Structures: if then [elseif then] ... [else] endif,
while do endwhile, repeat until endrepeat, for from to [by] do endfor (mehrere
Ausdruecke zwischen den Teilen eines control constructs, durch Komma getrennt,
sind moeglich; alle werden ausgewertet, der Wert des letzten Ausdrucks zaehlt).
Variablen muessen mit \"var::wert\" definiert werden; Werte von Variablen wer-
den mit \"var:wert\" geaendert. - \"load([filename])\" laedt esl Code aus der
Datei [filename], Pfadangabe ist moeglich. - Funktion definieren mit \"f(a1,
a2,...)::expression\", lokale Variable mit \"with l1::v1,l2::v2,... do exp1,
exp2, ... endwith\". Funktionsaufruf: \"f(p1,p2,...)\" (Parameter in Klammern,
durch Kommas voneinander getrennt). Die Parameter koennen beliebige Ausdruecke
sein, sie werden alle ausgewertet, die Werte werden an die Funktion uebergeben
(Semantik wie in scheme). - Arrays definieren mit a::[1..n,1..m], Zugriff:
a[i,j], beliebige Dimensionenszahl. - Konstanten pi (= 3.1415...) und e
(2.71828...) sind vordefiniert. Beispiele fuer esl-Code u.a. in den Dateien
funs.e, gauss_quad.e, linear_algebra.e; diese Dateien werden beim esl-Start
geladen; ansehen mit \'less(\"/usr/local/esl/funs.e\");\' ... ."|;

uname()::(&string2symbol("vector->list"))((&string2symbol("uname"))());

shelp(+tl)::
with
  topic::if nullq(tl) then "overview" else first(tl) endif
do
  if topic = "intro" then
    displaysl(helptext)
  elseif topic = "invalid" then
    displayln("The help topic you have entered is syntactically invalid.")
  elseif topic = "sysinfo" then
    displayln("esl ",&string2symbol("eslversion")),
    display("Scheme system is ",$scheme_system),
    if(symbol2string($scheme_system) = "guile") then
      displayln(" version ",(&string2symbol("version"))() ),
      displayln("Operating system information"),
      displayln(uname())
    else
      displayln("")
    endif
  else
    if $system_procedure_available then
      if $path = '$system then
        system($viewer//" "//$systempath//"/"//$helpdir//"/"//topic//".eh")
      else
        system($viewer//" "//$helpdir//"/"//topic//".eh")
      endif
    else
      displayln("Help on ",topic,
        " is not available, when esl runs on top of ",$scheme_system,"."),
      displayln("Only \nhelp(\"intro\")\n is available.")
    endif
  endif
endwith;

displayln("\nModule \"help\" (Version ",help_version,", ",help_date,")");
