============
Help on esl
============

Try one of

help intro;
help functions;
help operators;
help control;
help plot;
help sketch;
help sysinfo;
help semantics;
help syntax;
help commandline;
help changes;
help system;

to get some information, e.g. type

help functions;

for help on esl functions. The names of the help topics should be self-
explaining.

In most cases the help viewer uses unix "less".
Leave the help viewer by typing a q (the single letter q), if necessary.
Some help topics do not require an explicit exit.

esl basics
==========
1. Do not forget the semicolon at the end of the statement(s). Processing of
statements (called "evaluation") in esl does not start unless you type in
the semicolon. The semicolon separates evaluation units.

2. The delimiting character within structures (control structures, function
calls, ...) is always the comma. The comma delimits arguments and
statements. You may enter several statements, delimited by commas, before you
enter a semicolon and [return key] to start evaluation.

3. esl is (contrary to most scheme systems) case sensitive.

4. Input may consist of several lines. The newline character only means
"white space" (the same as e.g. a space character).

5. Function calls with exactly one simple argument may be written without
parentheses:

sin x

is equaivalent to

sin(x)


6. When esl crashes, you will usually be thrown back to the scheme prompt.

Typing

scheme();

in esl will bring you to scheme. The scheme procedure call

(esl)

will bring you back to esl. The esl variables keep their values.

7. Hint: Look at the esl code contained in the files
   /usr/local/esl/*.e
