                          esl semantics         first version 30.01.2005
                          *************         last revision 05.02.2005

esl semantics is scheme semantics. See

http://www.schemers.org/Documents/Standards/R5RS/

esl syntax is converted to scheme syntax and then evaluated as scheme
syntax.
Try
parseon();
This enables the output of the parsed esl input before evaluation. 
Note that esl symbols are prepended with a dollar sign. Do not enter this
dollar sign when working in esl.
parseoff();
turns off this feature.

Not all features of scheme are accessible in esl. This refers for example to
continuations, delayed execution, the macro capabilities of scheme.

All statements have a value. The value may be something like "unspecified".
Statements may have effects on the environment (changing a variable's value,
outputting something, ...). These effects are called "actions". You can ignore
the value.
Functions and operators may use standard evaluation (each argument or operand
is evaluated, for functions calls even the statement in the function position
is evaluated), or the evaluations proceeds in some "special" way. For example,
the assignment
a:=b;
does not evaluate a. It does, however, evaluate b.

Some further import points:

1. Variables must be defined before use. Definition implies assigning a
   value:

   a::5;

   f:: x->x*x;
 
   Definitions return an "unspecified" value. Do not try to use this value.

2. Assignments:
   a := ...
   a : ....
   Examples
   a:=54*3
   a: 54*3
   The simple form (only a colon) should be used only in interactive esl.
   It returns the assigned value. You can write something like
   a:b:l:0
   which assigns zero to a, b, l.
   := return an undefined value, it is faster. ":" is a macro (sort of).

3. Functions are first class objects. You can assign functions as values
   to variables, you can use functions as arguments in procedere calls.
   Do not confuse a function with the symbol of the function. The former
   is the value of the latter. 

   Possible values of variables are functions, numbers, strings, symbols,
   logical values, lists, vectors (and some more).
   
   Something like 
   x -> [expr x]
   is a pure function. x is a dummy variable, [expr x] is an expression
   (usually) containing x.
   f::x-> [expr x]
   assings the function to the name f.
   f(x) :: [expr x]
   is only syntactical sugar for the last statemant.
   You may even write
   f x :: [expr x];
   since parentheses can be omitted if exactly one argument is used in
   a function expression. Always use parantheses for more than one arguments,
   or when in doubt.

   After defining f, 
   g::f;   
   assigns g the same value as f. The value may be a function.

   Example:

   delta(f)::f(0);
   or simply
   delta f :: f 0;

   defines Dirac delta function. It is, in fact, a function assigning numbers
   to functions. delta(5) does not make sense (and produces an evaluation
   error).
   Try something like
   delta (sin);
   delta (cos);
   delta (x->sin(x-pi/4));

   shift(f,x)::(t->f(t-x));
   creates a shift by x of function f.

   Try
   delta(shift(sin,pi/4));

4. There are no type declarations (scheme, and esl, are "weakly typed 
   languages"). Values have types, variables have not.

5. Lexical scoping controls the visibility of variables. Functions may
   be defined locally (within other functions). Refer to scheme documentation
   for lexical scoping (in contrast to dynamic scoping).

6. pi (= 4*atan 1) and e (= exp 1) are "predefined". Do not try to redefine
   these variables.

7. Simple output:
   displayln (epx1, exp2, ...)
   It takes any number of arguments to be output, and adds a newline at the
   end.

8. You can write esl code in a file and "load" that file into interactive
   esl by something like
   load "testfile"
   or
   loadsys "testfile"
   The latter form is to be used if the file is in /usr/local/esl.
   You can use load with full path name.
   The preferred extension for files of this kind is ".e". This extension
   may be omitted when specifying the load statement.

9. There are lists and arrays in esl (lists are the most import data
   structures in scheme and other lisp-like languages).
   esl lists and arrays are described in the syntax help text.

10. When you enter the name of procedure as statement as in
    sin
    this name will be evaluated (as is done with any symbol). The value of
    a procedure symbol is the (implementation of) the procedure itself. Since
    this cannot be reasonably displayed, something different is displayed,
    typically a template for a call of the function. This works with
    "built-in" procedures as well as with esl or user defined procedures.
    Note that it does not work with macros, even if they look like procedures.
    For example, you can use
    push(el,li)
    to push the element el into the list li, but this is a macro (push
    modifies the list argument), and the statement
    push;
    will produce an evaluation error.

11. See also
    help "intro";
    help "functions";
    help "operators";
    help "control";
    help "syntax";

12. View some of the file "*.e" in /usr/local/esl.

