highplot_version::"0.2",highplot_date::"11.01.2000";

plotbars(xout,l)::
with
  d :: {},
  k :: 1,
  fl :: #t
do
  while fl : pop(l) do
    if numberq(fl) then
      push({k-0.3,fl,number2string(k)},d),
      k++
    elseif listq(fl) and length(fl:dropdd(fl))==1 and numberq(first(fl)) then
      push({k-0.3,first(fl),number2string(k)},d),
      k++
    elseif     listq(fl) and length(fl:dropdd(fl)) == 2 
           and numberq(first(fl)) and stringq(second(fl)) then
      push({k++-0.3,first(fl),second(fl)},d)
    else
      displayln("plotbars - invalid element: ",fl),
      k++
    endif
  endwhile,
  if nullq(d) then
    "plotbars: No valid element"
  else
    if xout then
      xplot({'bars,0.9,0,makematrix(reverse(d))},#f,{'auto,'noxcoords})
    else
      plot({'bars,0.9,0,makematrix(reverse(d))},#f,{'auto,'noxcoords})
    endif
  endif
endwith;

bar(+l) :: plotbars(#f,l);

xbar(+l) :: plotbars(#t,l);

plotlinreg(xout,l) ::
with
  round3(x)::if abs(x) < 10e-12 then 
               0
             else 
               roundn(x,3-floor(log(10,abs(x))))
             endif,
  dat :: {},
  el  :: #f,
  fl  :: #f,
  n   :: 0,
  sumx  :: 0,
  sumy  :: 0,
  xquer :: 0,
  yquer :: 0,
  sqx   :: 0,
  acoef :: #f,
  bcoef :: #f,
  xmin  :: #f,
  xmax  :: #f
do
  if listq(l) and length(l) = 1 then l := first(l) endif,
  if not listq(l) or length(l) < 2 then
    "Invalid argument(s), or only one pair of numbers in the list"
  else
    el := l,
    fl := dropdd(first(l)),
    while listq fl and length(fl) = 2
                      and numberq(first(fl)) and numberq(second(fl)) do
      push(fl,dat),
      fl := if listq(el : rest(el)) and length(el) > 0 then 
              dropdd(first(el)) 
            else 
              #f
            endif
    endwhile,
    if not nullq(el) then
      "Invalid element in list"
    else
      dat := makematrix(dat),
      n   := highindex(dat,1),
      xmin := dat[1,1],
      xmax := xmin,
      for i from 1 to n do 
        sumx := sumx + dat[i,1],
        sumy := sumy + dat[i,2],
        xmin := min(xmin,dat[i,1]),
        xmax := max(xmax,dat[i,1])
      endfor,
      xquer := sumx/n,
      for i from 1 to n do sqx := sqx + (dat[i,1]-xquer)^2 endfor,
      if  sqx < 1.0E-8 then
        "Alle x-Werte sind gleich oder fast gleich."
      else 
        yquer := sumy/n,
        bcoef := sum i-> (dat[i,1]-xquer)*(dat[i,2]-yquer) from 1 to n endsum
                                                                   / sqx,
        acoef := yquer - bcoef * xquer,
        displayln("in plotlinreg, vor if xout, xout is ",xout),
        if xout then
          xplot({ {dat,{'dr,'sq},{'si,"6"},
                  {'leg,"Data points, n = "//number2string(n)}},
                  {x->acoef+x*bcoef,
                     {'ra,xmin,xmax},
                     {'leg,
                        "Regression line: y = "
                       //number2string(round3(acoef))
                       //if bcoef < 0 then " - " else " + " endif
                       //number2string(round3(abs(bcoef)))
                       //" * x"}}
                },
                #f,{'auto,{'title,"Linear regression"}})
        else
          plot({ {dat,{'dr,'sq},{'si,"6"},
                  {'leg,"Data points, n = "//number2string(n)}},
                  {x->acoef+x*bcoef,
                     {'ra,xmin,xmax},
                     {'leg,
                        "Regression line: y = "
                       //number2string(round3(acoef))
                       //if bcoef < 0 then " - " else " + " endif
                       //number2string(round3(abs(bcoef)))
                       //" * x"}}
                },
                #f,{'auto,{'title,"Linear regression"}})
        endif,
        {n,acoef,bcoef}
      endif
    endif
  endif
endwith;

linreg(+l)  :: plotlinreg(#f,l);
xlinreg(+l) :: plotlinreg(#t,l); 
    
displayln("\nModule \"highplot\" (Version ",highplot_version,", ",
                                     highplot_date,")");
