plot_version::"0.16.11",plot_date::"25.01.2005";
*** previous version: "0.16.10",plot_date::"06.03.2004";

                           *** Overview ***

*** The procedures in this file can be used to generated function plots
*** (something similiar to gnuplot, but fewer options). The output format is
*** eps (encapsulated postscript). Actually, it is rather simple postscript,
*** whithout procedure definitions, transformation matrices and the like.
*** The necessary coordinate transformations are performed by plot.

*** You can draw several functions in one plot, you can draw parametric
*** plots (normal and parametric can even be mixed in one plot). There are
*** several drawing styles ("line", "filled", "closed", "impulses"). You can
*** also generate a chain of symbols (e.g. a chain of small squares) that
*** indicates the function values.
*** You can draw bar charts.
*** You can mix normal plots, symbols and bar charts.
*** You can add auxiliary graphics elements (e.g. lines, text). plot can even
*** be used to insert arbitrary postscipt code in the output file.

              *** Structure of the plot procedures ***

*** There are two procedures for the creation of plots and some auxiliary
*** procedures.

*** plot(funspecs,funrange,plotrange,extras) is the main plot procedure.
*** It creates a file in eps format (encapsulated postscript) that contains
*** the plot. The name of this file is by default ".tempplot.eps", it is
*** placed in the current directory. Further invocations of plot (or xplot,
*** see below) overwrite this file.

*** viewplot() displays the last plot file generated by plot.

*** xplot(funspecs,funrange,plotrange,extras) combines plot and viewplot.
*** It generates the plot file ".tempplot.eps" and then displays this plot.

*** editplot() edits the generated plot file as text. You can modify the
*** postscript code, if you like. In most cases this should not be necessary.

*** saveplot([filespec]) copies the last plot file to [filespec].

*** setmono() sets defaults which are meant to be used for monochrome devices.

*** setcolored() sets defaults for color devices (this is the default).

*** Call plot (and xplot) with 1 to 4 arguments. There are default values
*** for the second to fourth argument. You may omit trailing arguments, in
*** this case the default values will be used. The values 0 or #f or {} for
*** for an argument also meanw "use defaults".
*** The arguments to the plot procedure are explained in detail elsewhere.
*** I tried to make the simple things simple and some not so simple things
*** possible. With "xplot(sin)" you will get a plot of the sine function
*** in the range from 0 to 10. You can specify any range with something like
*** xplot(sin,0..2*pi). The third argument specifies properties of the
*** plot range . If the third argument is set to the list {'a4w,'auto}, then
*** the width of the generated plot should fit the width of a4 paper, and the
*** height of the plot is determined so that the height/width ratio is equal
*** to the original one, i.e., if axis are displayed then one unit on the
*** x-axis is equal to  one unit on the y-axis on the plot. This may not
*** always be desirable, so you can specify the plot range explicitely by
*** setting the third parameter to, say {400,300}.
***
*** The fourth parameter specifies additional graphics elements.

*** The definitions before the line "Do not modify the following ..." in
*** this file are meant to be "user-modifieable". Most of these definitions
*** specify default values for the plot. After loading of this file (plot.e)
*** you can modify these default values by simple assignments. If, for
*** example, you want the plot files to be stored as "plot.eps" in the current
*** directory, use the statement
***   tempplotfile := "plot.eps";
*** So you do not have to change this file. 
*** There are also some simple procedures which determine the logic of some
*** auxiliary elements on the plot (e.g. coordinate lines and text on these
*** lines). The definition of symbols (squares, circles, ...) can be extended.
*** This requires some elementary knowledge of the postscript language and,
*** of course, the esl language.

*** Unit for length measurements is "point" (1 pt = 1/72 inch = 0.352778 mm).
*** Postscript uses the same unit.

**********************
*** Default values ***
**********************

*** General ***

adobespec         :: "%!PS-Adobe-3.0 EPSF-3.0", *** This becomes the first
                                                *** line of the eps file

documenttitle     :: "(esl plot file)", *** This is copied in the "%%Title:"
                                        *** line of the eps file
tempplotfile      :: ".tempplot.eps",   *** Name of the generated plot file;
                                        *** it is saved in the current dir.

epsviewer         :: "gv -antialias ", 
                           *** the X program for eps view ("ghostview" is
                           *** also ok). I think it should also be possible
                           *** to use ghostscipt alone. However, gv allows
                           *** magnification in an easy way.
                           *** "antialias" improves rendering quality,
                           *** however, it takes more time to render.

defaulttitleshift :: 25,   *** This vertical space that is included when
                           *** a title is specified.
titlefont         :: "Helvetica", *** Font for the plot title 
titlefontspec     :: "/"//titlefont//" findfont 18 scalefont setfont",
*** Postscript statement for the title font. You can select another size.

*** Margins ***
xabsshift :: 50,  *** left margin. It is greater than other margin because some
                  *** space is needed for the numbers at the coordinate lines
yabsshift      :: 18,  *** bottom margin
xmargin        :: 10,  *** right margin
ymargin        :: 10,  *** top margin
xreduction     :: 30,  *** Reduction of xshift if there are no y coordinate lines
latex          :: #f,  *** latex = #t: more symmetric margins in x-direction.
xmarginbias    :: 5,   *** This should make it easier to include the plot
                       *** graphics into latex documents.

*** Defaults for function range ***
defaultfunlow     :: 0.0,  *** You really should not rely on the defaults for
defaultfunhigh    :: 10.0, *** funlow and funhigh. However, the value 100 for 
defaultnsub       :: 100,  *** defaultnsub might often be quite reasonable.

*** Defaults for plot range ***
a4plotwidth       :: 425,  *** unit is "point" (1/72 inch, as in postscript).
                           *** 425 pt = 15 cm.
defaultplotheight :: 300,  *** defaultplotheight is only used if plotheight is
minheightwidth    :: 0.3,  *** not specified as parameter and the functions'
maxheightwidth    :: 1.55, *** heigth/width ratio is <= minheightwidth or
                           *** >= maxheightwidth. defaultplotheight is not
                           *** used when 'auto is specified.
defaultplotwidth  :: a4plotwidth,  *** defaultplotwidth is used, if width
                                   *** is not specified in any way.  

*** Defaults for extra graphics ***
defaultlinewidth  :: 0.8,        *** These defaults are used for the "extra"
defaultlinedashing:: "[] 0 ",    *** parameter (4th argument of plot).
defaultlinecolor  :: "0 0 0 ",
defaultfont       :: "Helvetica",
defaultfontspec   :: "/"//defaultfont//" findfont 12 scalefont setfont",


*** Defaults for bar frames ***
drawbarframes           :: #t,      *** If set to #f, no bar frames are drawn
defaultframelinewidth   :: 1.2,     *** These defaults are used for bar frames
defaultframelinedashing :: "[] 0", 
defaultframelinecolor   :: "0 0 0 ",
defaultbarfill          :: 0.7,

*** Coordinate lines and text ***  Sets defaults for coordinate lines and text
coordlinewidth    :: 0.3,
coordlinedashing  :: "[0.7 2] 0 ",
coordlinecolored  :: "1 0 1 ",         *** this is the color "magenta"
coordlinecolor    :: coordlinecolored,
coordtextsize     :: "12",
coordtextfont     :: "Helvetica",
coordtextcolor    :: "0 0 0 ",
nulllinewidth     :: 0.3,      *** graphics attributes for the axes (only
nulllinedashing   :: "[] 0 ",  *** drawn if they are within the funrange
nulllinecolor     :: "0 0 0 ",
catchaxis         :: 0.101,    *** adapts x and y funrange so that the axes
                               *** will be included, if they are "nearly"
                               *** in the range 
                               *** (if ymin/(ymax-ymin) < catchaxis)
catchcoordline    :: 0.101,    *** "catches" coordinate lines different from
                               *** axes (works only for horizontale lines!).
*** If you set the catch-number to zero and plot x->1/x (or similar functions),
*** on, say 0..60, you will see the effect. If set to zero, no "catch" will
*** occur.

*** Legend ***
legendtextsize    :: 12,
legendtextfont    :: "Helvetica",
defaultlegendshift:: 16,

*** Accuracy ***
decplaces         :: 2,  *** decimal places for postscript draw and move
                         *** statements (lineto, moveto, rlineto, ...)
scaledecplaces    :: 4,  *** decimal places for width, dashing, ...

*** Defaults for the attributes of the functions ***

*** There are one array (matrix) for color devices and three for monochrom
*** devices. There corresponding functions for the selection of an array
*** (setcolored, setmono, ...).
*** Each line specifies (in order): color (rgb values, between 0 and 1 as
*** three-element list),line width (in "points") as string, drawing style
*** as symbol (valid values are 'line, 'fill, 'imp, 'clos, see below),
*** dashing as string ("[] 0" means no dashing, i.e. continuous line).
*** The last three items in a line are placeholders, they are set later
*** automatically. "simple" (5th column) is the counterpart to "parametric".
*** Meaning of drawing styles
*** line : usual style (line)
*** fill : fills the area between curve and x-axis
*** imp  : "impulses", draws vertical lines from x-axis to points on curve
***        for each x-value for which the function value is calculated
*** clos : combination of line and imp. The x-axis under the curve is also
***        drawn.

*** The lines of the plotspecs are used in order (1, 2, ...) for the 
*** individual objects in the first argument of plot (xplot). If there
*** are more functions then lines in the matrix, the lines are "reused"
*** (again starting from line 1).
*** These default values may be overwritten with appropriate function
*** attributes when calling plot (or xplot, respectively).

     *** Defaults for output on color devices ***
plotspecscolored  :: makematrix({          
 {{1.0,0.0,0.0},"0.6",'line,"[] 0",'simple,{},"4",{}},*** red
 {{0.0,0.8,0.0},"0.6",'line,"[] 0",'simple,{},"4",{}},*** green (little darker)
 {{0.0,0.0,1.0},"0.6",'line,"[] 0",'simple,{},"4",{}},*** blue
 {{0.6,0.4,0.0},"0.6",'line,"[] 0",'simple,{},"4",{}},*** some sort of brown
 {{0.6,0.0,0.6},"0.6",'line,"[] 0",'simple,{},"4",{}},*** dark magenta
 {{0.0,0.6,0.6},"0.6",'line,"[] 0",'simple,{},"4",{}} *** dark cyan
}),

     *** Defaults for monochrome device ***
plotspecsmono       :: makematrix({
 {{0,0,0},"1.2",'line,"[] 0",'simple,{},"4",{}},      *** The units for
 {{0,0,0},"0.6",'line,"[] 0",'simple,{},"4",{}},      *** dashing are "points"
 {{0,0,0},"0.6",'line,"[2 2] 0",'simple,{},"4",{}},  
 {{0,0,0},"1.6",'line,"[1 4] 0",'simple,{},"4",{}}, 
 {{0,0,0},"0.6",'line,"[4 4] 0",'simple,{},"4",{}}, 
 {{0,0,0},"0.6",'line,"[2 2 5 2] 0",'simple,{},"4",{}}  
}),

plotspecsmono1      :: makematrix({
 {{0,0,0},"0.6",'line,"[] 0",'simple,{},"4",{}},       *** The units for
 {{0,0,0},"0.6",'line,"[12 12] 0",'simple,{},"4",{}},  *** dashing are "points"
 {{0,0,0},"0.6",'line,"[5 5] 0",'simple,{},"4",{}},  
 {{0,0,0},"0.6",'line,"[5 5 12 5] 0",'simple,{},"4",{}},
 {{0,0,0},"0.6",'line,"[2 6] 0",'simple,{},"4",{}}, 
 {{0,0,0},"0.6",'line,"[6 4] 0",'simple,{},"4",{}} 
}),

plotspecsmono2      :: makematrix({
 {{0,0,0},"0.6",'line,"[] 0",'simple,{},"4",{}},       *** The units for
 {{0,0,0},"0.6",'line,"[4 4] 0",'simple,{},"4",{}},     *** dashing are "points"
 {{0,0,0},"1.5",'line,"[1.5 2.5] 0",'simple,{},"4",{}},  
 {{0,0,0},"0.6",'line,"[1.5 2 5 2] 0",'simple,{},"4",{}},
 {{0,0,0},"0.8",'line,"[2 6] 0",'simple,{},"4",{}}, 
 {{0,0,0},"0.6",'line,"[6 4] 0",'simple,{},"4",{}} 
}),

*** The dashing is specified as in postscript: A list of space-separated 
*** numbers, in square bracket, followed by a space and another number, the
*** whole thing as a string. This is copied to the postscript file "as is".
*** Invalid values may produce eps files that crash the postscript interpreter.

***********************
*** Initializations ***
***********************

*** The following definition of some colors is meant to be used as function
*** attributes or in the "extras"-list (fourth argument to plot and xplot).
*** These definitions should make the specification of complicated arguments
*** for plot easier. If not explicitely used, there is no influence on plot,
*** i.e. if you redefine these variables but do not use them, the plots
*** will look the same. If you want to modify the default colors for the
*** functions, you must change "plotspecs". The letter "p" should indicate
*** the use for "plot", the rest of the names should be self-explainatory.

pblack::{'rg,0,0,0},
pred::{'rg,1,0,0},
pgreen::{'rg,0,1,0},
pblue::{'rg,0,0,1},
pcyan::{'rg,0,1,1},
pmagenta::{'rg,1,0,1},
pyellow::{'rg,1,1,0},
pwhite::{'rg,1,1,1},
plightgray::{'rg,0.9,0.9,0.9},
pgray::{'rg,0.7,0.7,0.7},
pdarkgray::{'rg,0.45,0.45,0.45};

*** Some plot symbols (use instead of the drawing styles "line", "fill", ...)

invisiblesym(si,sp) :: "closepath",

squaresym(si,sp) ::
with s::#f,s2::#f,s2n::#f do
  if numberq(si) then 
    s  := number2string(roundn(sp(si*0.5),scaledecplaces))//" ",
    s2 := number2string(roundn(sp(si),scaledecplaces))//" "
  else
    s2 := si//" ",
    s  := number2string(string2number(si)*0.5)//" "
  endif,
  s2n := "-"//s2,
  s//s//"rmoveto "//s2n//"0 rlineto 0 "//s2n//"rlineto\n"
                                               //s2//"0 rlineto closepath"
endwith;

trisym(si,sp) ::
with a::#f,a3h::#f,c::#f,ch::#f do
  if stringq(si) then 
    si := string2number(si),
    sp := (x->x)
  endif,
  si  := 0.8*si,
  a   := number2string(roundn(sp(si),scaledecplaces)),
  a3h := number2string(roundn(sp(si*1.5),scaledecplaces)),
  ch  := number2string(roundn(sp(si*sqrt(3)*0.5),scaledecplaces)),
  c   := number2string(roundn(sp(si*sqrt(3)),scaledecplaces)),
  "0 "//a//" rmoveto -"//ch//" -"//a3h//" rlineto "//c
                                                //" 0 rlineto closepath"
endwith,

circlesym(si,sp) ::
begin
  if stringq(si) then  
    si := string2number(si)
  else
    si := sp(si)
  endif,
  si := number2string(roundn(si/sqrt(pi),scaledecplaces)),
  "currentpoint "//si//" 0 rmoveto "//si//" 0 360 arc"
end;

plotspecsdefault :: plotspecscolored;  *** Use color plotspecs as default

setmono()        ::    *** setmono() sets defaults for monochrome output
begin
  plotspecsdefault := plotspecsmono,
  coordlinecolor   := "0 0 0 ",
  latex            := #f
end;

setmono1()        ::    *** setmono1() sets other defaults for monochrome output
begin
  plotspecsdefault := plotspecsmono1,
  coordlinecolor   := "0 0 0 ",
  latex            := #f
end;

setlatex()        ::    *** setlatex() sets other defaults for monochrome output
begin                   *** to be used for latex eps images.  
  plotspecsdefault := plotspecsmono2,
  coordlinecolor   := "0 0 0 ",
  latex            := #t
***  xmargin          := xabsshift - xmarginbias 
end;

setcolored()     ::    *** setcolored() sets defaults for color output
begin                  *** This is the default.
  plotspecsdefault := plotspecscolored,
  coordlinecolor   := coordlinecolored,
  latex            := #f
end;

viewplot()  :: system(epsviewer//" "//tempplotfile//"&"); 
*** I am not sure if this always works
 
saveplot(s) :: system("cp "//tempplotfile//" "//s);  
*** saveplot("nnnnn") saves the current plot file as nnnnn 
                                                       
editplot()  :: ed(tempplotfile); *** editplot() edits the current plot file
                                 *** as (postcript) text.

viewplotfile(s) :: system(epsviewer//" "//s//"&");

***************************************************************
*** Do not modify the following unless you are really sure. ***
***************************************************************

**********************************
*** Some auxiliary definitions ***
**********************************

dataspec(d) ::  (   procedureq(d) 
                 or stringq(d)
                 or (listq(d) and length(d) = 4 and first(d) = 'bars) 
                 or matrixq(d) );

s2fnumber         :: 'undef; *** for the generation of unique function names
                             *** (for some reason, this has to global.)

s2f(s,n)::
with
  l    :: string2list(s), 
  ll   :: length(l),
  r1   :: char("(") in l,
  r2   :: char(")") in l,
  r3   :: char("=") in l,
  l1   :: 'undefined,
  l2   :: 'undefined,
  l3   :: 'undefined
do
  if      r1 and r2 and r3 
      and (l1 : ll-length(r1)) < (l2 : ll-length(r2)) 
      and l2 < (l3 : ll-length(r3)) then
    "__"//number2string(n)//"("//substring(s,l1+2,l2)//")::"
         //substring(s,l3+2,ll)
  else
    #f
  endif
endwith;

s2ffunentry(l) ::
if stringq(l) then
  s2fnumber++,
  evalstring(s2f(l,s2fnumber)),
  list(&string2symbol("$__"//number2string(s2fnumber)),list('leg,l))
elseif listq(l) and not nullq(l) and stringq(first(l)) then
  append(s2ffunentry(first(l)),rest(l))
else 
  l
endif;

s2ffunlist(f) ::
if not listq(f) or nullq(f) then
  f
else
  cons(s2ffunentry(first(f)),s2ffunlist(rest(f)))
endif;

plot4 ::

with

  out       :: #f,
  a11::1.0, a12::0.0, a21::0.0, a22::1.0,
  xshift::0.0, yshift::0.0,                ***transformation parameters
  fontlist   :: {},
  funlow     :: #f,
  funhigh    :: #f,
  funstep    :: #f,
  xmar       :: 0,

  ct2s(xu,yu)::   *** Coordinate-Transform, to string
    number2string(roundn(a11*xu+a12*yu+xshift,decplaces))//" "
     //number2string(roundn(a21*xu+a22*yu+yshift,decplaces)),

  scalenumber(num) :: a11*num,

  do_pslist(pl)::
  begin
    while not nullq(pl:rest(pl)) do
      if numberq(first(pl)) 
         and not nullq(rest(pl))
         and numberq(second(pl))
      then
        display(out,ct2s(first(pl),second(pl))," "),
        pl:=rest(pl)
      elseif listq(first(pl))
         and length(first(pl))=2
         and first(first(pl))= 'scale
         and numberq(second(first(pl)))
      then
        displayln(out,
          roundn(scalenumber(second(first(pl))),decplaces)," ")
      else 
        display(out,first(pl)," ")
      endif
    endwhile,
    displayln(out,"")
  end,

  do_one_spec(h)::
  begin 
    if ddlistq(h) then h := rest(h) endif,
    with
      firsth :: if listq(h) then first(h) else #f endif,
      d :: #f
    do
      if firsth = 'li then
        if numberq(second(h)) and numberq(third(h)) then
          displayln(out,"newpath ",ct2s(second(h),third(h))," moveto"),
           displayln(out,
             ct2s(fourth(h),fourth(rest(h))),
           " lineto stroke")
        elseif length(h) = 3 and stringq(second(h)) and stringq(third(h)) then
          displayln(out,
                 "newpath ",second(h)," moveto ",third(h)," lineto stroke")
        else
          display("Invalid line specification ignored:",h)
        endif
      elseif firsth='wi then
        displayln(out,
                  if numberq(second(h)) then 
                    roundn(scalenumber(second(h)),scaledecplaces)
                  else
                    second(h)
                  endif,
                  " setlinewidth"
                 )
      elseif firsth='rg then
        displayln(out,second(h)," ",third(h)," ",fourth(h)," setrgbcolor")
      elseif firsth='fo then
        displayln(out,
                  "/",
                  second(h),
                  " findfont ",
                  if numberq(third(h)) then 
                    roundn(scalenumber(third(h)),scaledecplaces)
                  else
                    third(h)
                  endif,
                  " scalefont setfont"
                 ),
        fontlist := cons(second(h),fontlist)
      elseif firsth='ps then
        do_pslist(h)
      elseif firsth='te then
        if numberq(third(h)) then
          displayln(out,ct2s(third(h),fourth(h))," moveto")
        else
          displayln(out,third(h)," moveto"),
          h := append({first(h),second(h),third(h)},
                             {'inserted_element},rest(restofrest(h)))
        endif,
        if nullq(restofrest(restofrest(h))) then
          displayln(out,"(",second(h),") show")
        else
          displayln(out,"gsave ",fourth(rest(h))," rotate"),
          displayln(out,"(",second(h),") show grestore")
        endif
      elseif firsth='da then
        if stringq(second(h)) then 
          displayln(out,
            "["//second(h)//"] ",
            if not nullq(restofrest(h)) 
             and (numberq(third(h)) or stringq(third(h))) then
              third(h)
            else
              "0"
            endif, 
            " setdash"
          )
        else
          display(out,"[ "),
          d := rest(h),
          while not nullq(d) do
            if numberq(first(d)) then
              display(out," ",roundn(scalenumber(first(d)),scaledecplaces)),
              d := rest(d),
              if nullq(d) then
                displayln(out," ] 0 setdash")
              endif
            else
              display(out," ] "),
              if not nullq(rest(d)) and numberq(second(d)) then
                displayln(out,roundn(scalenumber(second(d)),scaledecplaces),
                            " setdash")
              else
                displayln(out," 0 setdash")
              endif,
              d := {}
            endif
          endwhile
        endif
      else 
        displayln("invalid spec element ignored ",h)
      endif
    endwith
  end,        *** end of local procedure do_one_spec

  do_extras(l)::

  with 
    h::#f,
    firsth::#f
  do
    if not l or listq(l) and nullq(l) or l=0 or l=0.0 then
      displayln("plot: no extra statements")
    elseif not listq(l) then
      displayln("plot: invalid extra statements - ignored.")
    else
      displayln(out,defaultlinewidth," setlinewidth"),
      displayln(out,defaultlinecolor,"setrgbcolor"),
      displayln(out,defaultlinedashing,"setdash"),
      displayln(out,defaultfontspec),
      fontlist := cons(defaultfont,fontlist),
      repeat
        h := first(l),
        do_one_spec(h)
      until
        nullq(l : rest(l))
      endrepeat
    endif 
  endwith, *** end of local procedure "do_extras"

  coordlines :: *** coordlines(low,high) returns a list 
  with          *** {v1,v2, ... ,'p, w1, w2, ...} where v1>v2>... and w1>w2>...
                *** and every "w" is a "v" . If you modify: there must be
                *** at least two "w" (and, therefore, also at least to "v").
    linevalues::makematrix({
      {2,0.2},
      {4,0.5},
      {10,1}
    }),
    nlinevalues :: highindex(linevalues,1),
    securityfac :: 1e-12  *** to compensate for rounding errors
  do
    (low,high) ->
    if not numberq(low) or not numberq(high) or low >= high then
      displayln(
       "coordlines: arguments must be numbers, the first one must be smaller.")
    else
      with 
        len       :: high - low,
        lglow     :: inexact2exact(floor(log(10,len))),
        normlen   :: len*10^(-lglow),
        linediffi :: 0,
        linediff  :: 'undefined,
        linelist  :: {},
        printlist :: {},
        ll        :: 'undefined
      do
        repeat
          linediffi++
        until
          linediffi > nlinevalues or normlen < linevalues[linediffi,1]
        endrepeat,
        if linediffi > nlinevalues then 
          displayln("coordlines: internal error")
        else
          linediff := linevalues[linediffi,2]*10^lglow,
          low      := low  - securityfac * linediff,
          high     := high + securityfac * linediff,
          linelist := {if low < 0 then
                        - truncate(1.0*abs(low - 1e-10)/linediff)*linediff
                      else
                        ceiling(1.0*low/linediff)*linediff
                      endif},
          while (ll : first(linelist) + linediff) <= high do
            linelist := cons(ll,linelist)
          endwhile
        endif,
        if nullq(linelist) then
          {}
        else
          if length(linelist) > 4 then linediff := 2*linediff endif,
          ll      := if low < 0 then
                        - truncate(1.0*abs(low)/linediff)*linediff 
                      else
                        ceiling(1.0*low/linediff)*linediff
                      endif,
          if abs(round(ll)-ll) < 1e-10 then ll := inexact2exact(ll) endif,
          printlist := {ll},          
          while linediff > 0 and (ll : first(printlist) + linediff) <= high do
            if abs(round(ll)-ll) < 1e-10 then ll := inexact2exact(ll) endif,
            printlist := cons(ll,printlist)
          endwhile,
          append(linelist,list('p),printlist)
        endif
      endwith
    endif
  endwith
  
do        *** begin of the code of plot4

  (f,funrange,plotrange,extras) ->

  if ddlistq(funrange) then
    plot4(f,rest(funrange),plotrange,extras)
  elseif ddlistq(plotrange) then
    plot4(f,funrange,rest(plotrange),extras)  
  elseif   (       not listq(funrange) 
            or length(funrange) < 2 
            or length(funrange) > 3
            or not numberq(first(funrange)) 
            or not numberq(second(funrange))
            or length(funrange)=3 and not numberq(third(funrange)))
       and funrange 
       and not funrange = 0
       and (not listq(funrange) or not nullq(funrange)) 
                                                                      then
    displayln
     ("Second argument must be a list of 2 or 3 numbers,",
                                          " or #f or 0 or an empty list")
  elseif
    if listq(funrange) and length(funrange) > 1 then
      funlow  := first(funrange),
      funhigh := second(funrange),
      funstep := if length(funrange) = 3 then 
                   third(funrange) 
                 else
                   1.0*(funhigh - funlow)/defaultnsub
                 endif
    else
      funlow  := defaultfunlow,
      funhigh := defaultfunhigh,
      funstep := 1.0*(funhigh - funlow)/defaultnsub
    endif,
    abs(funhigh-funlow)<1e-12 or abs(funstep) < 1e-12 
  then    
    displayln("difference between ",funlow," and ",funhigh,
         " too small, or \"step\" too small."),
    '{}
  elseif funhigh < funlow then
    plot4(f,{funhigh,funlow,funstep},plotrange,extras)
  elseif listq(f) and nullq(f) then
    displayln("First argument must not be an empty list.")
  else
    f := dropdd(f),
    with
      nsub      :: inexact2exact(ceiling((funhigh-funlow)/abs(funstep))),
      h         :: 1.0*(funhigh-funlow)/nsub,
      nfun      :: if not listq(f) then 
                     1 
                   elseif length(f) > 1 
                            and
                          not dataspec(second(f))
                            and
                          not (listq(second(f)) and dataspec(first(second(f))))
                                                                      then
                     1
                   else
                     length(f)  
                   endif,
      nplotspecsdefault      :: highindex(plotspecsdefault,1),
      rowlenplotspecs        :: highindex(plotspecsdefault,2),
      plotspecs   :: [1..nfun,1..rowlenplotspecs],
      values      :: [1..nfun],
      minx        :: 'undefined_minx,
      maxx        :: 'undefined_maxx,
      miny        :: 'undefined_miny,
      maxy        :: 'undefined_maxy,
      x           :: 0,
      y           :: 0,
      col         :: 0,
      cfun        :: 'undefined,
      titleshift  :: 'undefined,
      legendshift :: 0,
      funatts     :: #f,
      funtype     :: 'undefined,
      catt        :: #f,
      d           :: #f,
      diffval     :: 'undefined,
      plotwidth   :: #f,
      plotheight  :: #f,
      cvalues     :: {},
      xy          :: 'undefined,
      xy00        :: 'undefined,
      cll         :: 'undefined,
      coordset    :: #f,
      hs          :: "",
      symstring   :: "",
      plotcoordlines :: 'all,
      plottitle   :: "",
      prspec      :: 'undefined,
      bw          :: 'undefined,
      lowi        :: 'undefined,
      highi       :: 'undefined,
      barshift    :: 'undefined,
      tarray      :: 'undefined,
      xbmin       :: 'undefined,
      xbmax       :: 'undefined,
      bargroups   :: {},
      legendspec  :: #f,
      xp          :: 0,
      yp          :: 0
    do
      display(""),  *** This is because of a flaw in display (and displayln) 
      s2fnumber := 0,
      if not listq(f) then 
        f := {{f}} 
      elseif listq(f) and length(f) = 1 
               and dataspec(first(f)) then
        f := {f}
      elseif listq(f) and length(f) > 1 
             and not dataspec(second(f))
             and not (listq(second(f)) and  dataspec(first(second(f)))) then
        f := {f}
      endif,
      f := s2ffunlist(f),
      for i from 1 to nfun do
        for j from 1 to rowlenplotspecs-1 do
          plotspecs[i,j]:=plotspecsdefault[(i-1) mod nplotspecsdefault + 1,j]
        endfor,
        plotspecs[i,rowlenplotspecs] := {funlow,funhigh,nsub}
      endfor,
      
/* preprocessing of the functions (or bar specification) */
      
      display("\n"),

      for col from 1 to nfun do
        cfun := if dataspec(first(f)) then 
                  first(f) 
                else 
                  first(first(f))
                endif,
        if                  listq(first(f)) and not nullq(first(f))
                        and dataspec(first(first(f))) 
                        and not nullq(rest(first(f)))               then
          funatts := first(f),
          while not nullq(funatts:rest(funatts)) do
            catt := first(funatts),
            if not listq(catt) or length(catt) < 2 then catt := {#f} endif,
            catt := dropdd(catt),
            case first(catt)
            of dr, plotspecs[col,3] := second(catt)
            of si, plotspecs[col,7] := second(catt)
            of rg, if length(catt) = 4 then
                     plotspecs[col,1] 
                      := {second(catt),third(catt),fourth(catt)}
                   else
                     displayln("plot: Number of arguments to \"\'rg\"",
                                              "is invalid:",catt)
                   endif
            of wi, plotspecs[col,2] := second(catt)
            of da, plotspecs[col,4] 
                    := if length(catt) > 1 and numberq(second(catt)) then
                         rest(catt)
                       elseif stringq(second(catt)) then
                         if length(catt) = 3 and numberq(third(catt)) then
                           "["//second(catt)//"] "//number2string(third(catt))
                         elseif length(catt) = 3 and stringq(third(catt)) then
                           "["//second(catt)//"] "//third(catt)
                         else
                           "["//second(catt)//"] 0"
                         endif
                       else
                         displayln("plot: Invalid dashing for function",col,
                            "ignored:",catt)
                       endif
            of ra, if     listq(catt) 
                      and length(catt) >= 3
                      and numberq(second(catt))
                      and numberq(third(catt))
                      and (     length(catt) = 3
                            or  (length(catt) = 4 and numberq(fourth(catt)))
                          )                                      then
                     nsub := if length(catt) = 4 then  
                               inexact2exact(
                                   ceiling((third(catt)-second(catt))
                                                    /abs(fourth(catt)))
                               )
                             else
                               defaultnsub
                             endif,
                     plotspecs[col,rowlenplotspecs] 
                       := {second(catt),third(catt),nsub}
                   else
                     displayln("plot: Invalid range for function",col,
                        "ignored:",catt)
                   endif
            of leg, if length(catt) = 2 and stringq(second(catt)) then
                     plotspecs[col,6] := second(catt),
                     legendshift := defaultlegendshift
                   endif
            else 
              displayln("plot: Invalid attribut for function",col,
                            "ignored:",catt)
            endcase
          endwhile
        endif,
        funlow  := first (plotspecs[col,rowlenplotspecs]),
        funhigh := second(plotspecs[col,rowlenplotspecs]),
        nsub    := third (plotspecs[col,rowlenplotspecs]),
        h       := 1.0*(funhigh-funlow)/nsub,
        if listq(cfun) and length(cfun) = 4 and first(cfun) = 'bars then
          funtype          := 'bars,
          plotspecs[col,5] := 'bars
        elseif  matrixq(cfun) 
               and lowindex(cfun,2)  = 1 
               and highindex(cfun,2) = 2 then  
          funtype          := 'points,
          plotspecs[col,5] := 'points
        elseif procedureq(cfun) and listq(cfun(funlow)) 
                                          and length(cfun(funlow)) = 2 then
          funtype          := 'parametric,
          plotspecs[col,5] := 'parametric
        elseif procedureq(cfun) and numberq(cfun(funlow)) then
          funtype          := 'simple  
        else
          if nfun = 1 then
            displayln("Invalid function specification")
          else
            displayln("Function specification ",col," is invalid.")
          endif,
          funtype := 'invalid,
          plotspecs[col,5] := 'invalid
        endif,
        displayln(
            "*** function",col,"\nfunlow,funhigh,nsub,funstep,funtype: ",
            roundn(funlow,6),", ",roundn(funhigh,6),", ",nsub,", ",
                        roundn(h,8),", ",funtype),
        values[col] :=  
           if funtype === 'parametric then
             with ta :: [0..nsub,1..2] do
               xy := cfun(funlow),
               x  := first(xy),
               y  := second(xy),
               minx := if numberq(minx) then min(x,minx) else x endif,
               maxx := if numberq(maxx) then max(x,maxx) else x endif,
               miny := if numberq(miny) then min(y,miny) else y endif,
               maxy := if numberq(maxy) then max(y,maxy) else y endif,
               for i from 0 to nsub do
                 xy := cfun(funlow+i*h),
                 x  := first(xy),
                 y  := second(xy),
                 ta[i,1] := x,
                 ta[i,2] := y,
                 minx := min(minx,x),
                 maxx := max(maxx,x),
                 miny := min(miny,y),
                 maxy := max(maxy,y)
               endfor,
               ta
             endwith
           elseif funtype === 'simple then
             with ta :: [0..nsub,1..2] do 
               minx 
                 := if numberq(minx) then min(minx,funlow) else funlow endif,
               maxx 
                 := if numberq(maxx) then max(maxx,funhigh) else funhigh endif,
               miny := if numberq(miny) then
                        min(miny,cfun(funlow))
                      else
                        cfun(funlow)
                      endif,     
               maxy := if numberq(maxy) then
                        max(maxy,cfun(funlow))
                      else
                        cfun(funlow)
                      endif,     
               for i from 0 to nsub do
                 x := funlow+i*h,
                 y := cfun(x),
                 ta[i,1] := x,
                 ta[i,2] := y,
                 miny := min(miny,y),
                 maxy := max(maxy,y)
               endfor,
               ta
             endwith
           elseif funtype === 'bars then
             bw := second(cfun),
             barshift := third(cfun),
             tarray := fourth(cfun),
             if not (arrayq(tarray) and arraydim(tarray) = 2 
                       and (   highindex(tarray,1)-lowindex(tarray,1) > 0
                            or numberq(bw) and bw > 0) 
                    )                                              then
               plotspecs[col,5] := 'invalid,
               displayln
                ("data specification ",col," (for bars) is invalid"),
               {}
             else
               lowi   := lowindex(tarray,1),
               highi  := highindex(tarray,1),
               xbmin  := tarray[lowi,1],
               if not (numberq(bw) and bw > 0) then
                 bw := defaultbarfill*(tarray[lowi+1,1] - xbmin)
               endif,
               xbmax := xbmin,
               if numberq(miny) then 
                 miny := min(miny,tarray[lowi,2]) 
               else
                 miny :=tarray[lowi,2]
               endif,
               if numberq(maxy) then 
                 maxy := max(maxy,tarray[lowi,2]) 
               else
                 maxy := tarray[lowi,2]
               endif,
               for i from lowi to highi do
                 x := tarray[i,1],
                 y := tarray[i,2],
                 xbmin := min(xbmin,x),
                 xbmax := max(xbmax,x),
                 miny  := min(miny,y),
                 maxy  := max(maxy,y)
               endfor,
               miny := min(0,miny),
               if not numberq(barshift) then barshift := 0 endif,
               displayln("xbmin,xbmax ",xbmin,xbmax),
               if numberq(minx) then
                 minx := min(minx,xbmin + barshift - bw*0.5)
               else
                 minx := xbmin +barshift - bw*0.5
               endif,
               if numberq(maxx) then
                 maxx := max(maxx,xbmax + barshift + bw*0.5)
               else
                 maxx := xbmax + barshift + bw*0.5
               endif,
               if highindex(tarray,2) = 3 then
                 bargroups := {},
                 for i from lowi to highi do
                   bargroups := cons({tarray[i,1],tarray[i,3]},bargroups)
                 endfor
               endif,
               list(bw,barshift,tarray)
             endif
           elseif funtype === 'points then
             lowi   := lowindex(cfun,1),
             highi  := highindex(cfun,1),
             x      := cfun[lowi,1],
             y      := cfun[lowi,2],
              
             if numberq(minx) then minx := min(minx,x) else minx := x endif,
             if numberq(maxx) then maxx := max(maxx,x) else maxx := x endif,
             if numberq(miny) then miny := min(miny,y) else miny := y endif,
             if numberq(maxy) then maxy := max(maxy,y) else maxy := y endif,
             with ta::[0..highi-lowi,1..2] do
               for i from lowi to highi do
                 x := cfun[i,1],
                 y := cfun[i,2],
                 minx := min(minx,x),
                 maxx := max(maxx,x),
                 miny := min(miny,y),
                 maxy := max(maxy,y),
                 ta[i-lowi,1] := x,
                 ta[i-lowi,2] := y
               endfor,
               plotspecs[col,rowlenplotspecs] := {funlow,funhigh,highi-lowi},
               plotspecs[col,5] := 'parametric,
               ta
             endwith
           else
             {}
           endif,
        f := rest(f)
      endfor,

/*  End of preprocessing of the functions */

      if not numberq maxx or not numberq maxy then
        minx := 0, maxx := 0, miny := 0, maxy := 0 
      endif,
      if maxx-minx < 1e-10 then
        displayln("maxx-minx is very small: ",maxx-minx),
        minx := minx - 0.05,
        maxx := maxx + 0.05
      endif,   
      if maxy-miny < 1e-10 then
        displayln("maxy-miny is very small: ",maxy-miny),
        miny := miny - 0.05,
        maxy := maxy + 0.05
      endif,   

      if minx > 0 and  minx/(maxx-minx) <= catchaxis then minx := 0 endif,

      if maxx < 0 and -maxx/(maxx-minx) <= catchaxis then maxx := 0 endif,

      if miny > 0 and  miny/(maxy-miny) <= catchaxis then miny := 0 endif,

      if maxy < 0 and -maxy/(maxy-miny) <= catchaxis then maxy := 0 endif,
     
      cll := coordlines(miny,maxy),
      y   := first(cll),
      diffval := y - second(cll),
      if (maxy-y)/diffval >= 1-catchcoordline then maxy := y+diffval endif, 
     
      while numberq(second(cll)) do cll := rest(cll) endwhile,
      y := first(cll),
      if (y-miny)/diffval >= 1-catchcoordline then miny := y-diffval endif,
      
      if not plotrange or plotrange == 0 then plotrange := {} endif,
      if not listq plotrange then plotrange := {plotrange} endif,
      if not nullq(plotrange) and first(plotrange) === 'auto then 
        plotrange := cons('default,plotrange)
      endif,

      if length(plotrange) >= 2 
         and numberq(first(plotrange)) and numberq(second(plotrange))
         and first(plotrange) > 0 and second(plotrange) > 0          then
        plotwidth   := first(plotrange),
        plotheight  := second(plotrange),
        plotrange   := restofrest(plotrange)
      elseif not nullq(plotrange) 
         and (first(plotrange) === 'a4w or first(plotrange) === 'default  
                                            or numberq(first(plotrange))) then
        if first(plotrange) === 'a4w then
          plotwidth := a4plotwidth
        elseif first(plotrange) === 'default then
          plotwidth := defaultplotwidth
        else
          plotwidth := first(plotrange)
        endif,  
        plotrange   := rest(plotrange),
        if  not nullq(plotrange) and  first(plotrange) === 'auto 
           or   (nullq(plotrange) or not numberq(first(plotrange)))
              and (maxy-miny)/(maxx-minx) >= minheightwidth
              and (maxy-miny)/(maxx-minx) <= maxheightwidth then
          plotheight := 1.0*plotwidth * (maxy-miny)/(maxx-minx)
        elseif not nullq(plotrange) and numberq(first(plotrange)) then
          plotheight := first(plotrange)
        else
          plotheight := defaultplotheight
        endif,
        if not nullq(plotrange) 
            and (numberq(first(plotrange)) or first(plotrange) === 'auto) then
          plotrange := rest(plotrange)
        endif
      else
        displayln("Default procedure for plotrange will be used."),
        plotwidth  := defaultplotwidth,
        plotheight := if   (maxy-miny)/(maxx-minx) >= minheightwidth
                        and (maxy-miny)/(maxx-minx) <= maxheightwidth then
                        1.0*plotwidth*(maxy-miny)/(maxx-minx)
                      else
                        defaultplotheight
                      endif
      endif,
      while not nullq(plotrange) do
        prspec := dropdd(first(plotrange)),
        if prspec === 'nocoords then
          plotcoordlines := #f
        elseif prspec === 'noxcoords then
          plotcoordlines := 'y
        elseif prspec === 'noycoords then
          plotcoordlines := 'x
        elseif listq(prspec) and length(prspec)=2 and first(prspec)='title
                                                                        then
          plottitle := second(prspec)
        elseif listq prspec and length prspec >3 and first prspec ='leg then
          legendspec := rest prspec,
          if numberq first legendspec then
            legendshift := pop legendspec,
            legendspec  := append(legendspec,{'stop})
          else
             displayln("Invalid legendspec ignored: ",legendspec),
             legendspec := #f
          endif
        else       
          displayln("Cannot process plotrangespec ",prspec)
        endif,
        plotrange := rest(plotrange)
      endwhile,
      displayln("\n *** plotwidth, plotheight: ",plotwidth,", ",
                                        roundn(plotheight,4)),
      if legendspec then
         displayln("*** user supplied legendshift: ",legendshift,
                                        ", legendplaces are ",legendspec)
      endif,
      a11 := 1.0*plotwidth/(maxx-minx),
      a22 := if maxy-miny < 1e-10 then
              displayln("maxy - miny is very small: ",maxy-miny),
              0.1 
            else 
              1.0*plotheight/(maxy-miny) 
            endif,
      a12 := 0.0,
      a21 := 0.0,

      titleshift := if plottitle = "" then 0 else defaulttitleshift endif,
      xshift := -1.0*minx/(maxx-minx)*plotwidth+xabsshift,
      xmar := xmargin,
      if latex then xmar := xabsshift - xmarginbias endif,
      if plotcoordlines in {#f,'x} then
        xmar   := xmar - xreduction,
        xshift := xshift - xreduction,
        if latex then xmar := xmar - xreduction + 0.5*xmarginbias endif
      endif,
      yshift := -1.0*miny/(maxy-miny)*plotheight+yabsshift+titleshift
                                                             + legendshift,
      out    := openoutfile(tempplotfile),
      displayln(out,
                adobespec,
                "\n%%BoundingBox:  -2 -2 ",
                   roundn(plotwidth+2+xabsshift+xmar,scaledecplaces)," ",
                   roundn(plotheight+2+yabsshift+titleshift+ymargin
                                           +legendshift,    scaledecplaces),
                "\n%%Creator: (esl)",
                "\n%%Title: "//documenttitle,
                "\n%%Pages: 0",
                "\n%%DocumentFonts: (atend)",
                "\n%%EndComments"),
      fontlist := {},
      if plotcoordlines in {'all,'x} then
        displayln(out,coordlinewidth," setlinewidth\n",
                      coordlinecolor,"setrgbcolor\n",
                      coordlinedashing,"setdash"),
        cll := coordlines(minx,maxx),
        while not nullq(cll) and not (x : first(cll)) = 'p do
          displayln(out,"newpath ",ct2s(x,miny)," moveto ",ct2s(x,maxy),
                                                           " lineto stroke"),
          cll := rest(cll)
        endwhile,
        if length(cll) > 1 then
          displayln(out,coordtextcolor,"setrgbcolor"),
          displayln(out,"/",coordtextfont," findfont ",coordtextsize,
                         " scalefont setfont"),
          fontlist := cons(coordtextfont,fontlist),
          coordset := #t,
          while not nullq(cll : rest(cll)) do
            x := first(cll),
            displayln(out,"newpath ",ct2s(x,miny)," moveto\n0 -3 ",
                        coordtextsize," sub rmoveto (",x,") ",
                         "dup stringwidth pop -0.5 mul 0 rmoveto show")
          endwhile
        endif
      endif,

      if not nullq(bargroups) then
        displayln(out,coordtextcolor,"setrgbcolor"),
        displayln(out,"/",coordtextfont," findfont ",coordtextsize,
                         " scalefont setfont"),
        fontlist := cons(coordtextfont,fontlist),
        while not nullq(bargroups) do
          x := first(first(bargroups)),
          displayln(out,"newpath ",ct2s(x,miny)," moveto\n0 -3 ",coordtextsize,
                        " sub rmoveto (",second(first(bargroups)),") ",
                       "dup stringwidth pop -0.5 mul 0 rmoveto show"),
          bargroups := rest(bargroups)
        endwhile
      endif,

      if plotcoordlines in {'all,'y} then  
        displayln(out,coordlinewidth," setlinewidth\n",
                      coordlinecolor,"setrgbcolor\n",
                      coordlinedashing,"setdash"),
        cll := coordlines(miny,maxy),
        while not nullq(cll) and not (y : first(cll)) = 'p do
          displayln(out,"newpath ",ct2s(minx,y)," moveto ",ct2s(maxx,y),
                                                        " lineto stroke"),
          cll := rest(cll)
        endwhile,
        if length(cll) > 1 then
          displayln(out,coordtextcolor,"setrgbcolor"),
          displayln(out,"/",coordtextfont," findfont ",coordtextsize,
                       " scalefont setfont"),
          fontlist := cons(coordtextfont,fontlist),
          while not nullq(cll : rest(cll)) do
            y := first(cll),
            displayln(out,"newpath ",ct2s(minx,y)," moveto\n",
                   "0 ",coordtextsize," -0.3 mul rmoveto\n",
                   "(",y,") dup stringwidth pop -1 mul -3 add 0 rmoveto show")
          endwhile
        endif,
        if (minx <= 0 and maxx >= 0) or (miny <= 0 and maxy >= 0) then
          displayln(out,nulllinewidth," setlinewidth\n",
                    nulllinecolor,"setrgbcolor\n",
                    nulllinedashing,"setdash")
        endif,
        if minx <= 0 and maxx >= 0 then
          displayln(out,"newpath ",ct2s(0,miny)," moveto ",ct2s(0,maxy),
                                                          " lineto stroke")
        endif,
        if miny <= 0 and maxy >= 0 then
          displayln(out,"newpath ",ct2s(minx,0)," moveto ",ct2s(maxx,0),
                                                           " lineto stroke")
        endif
      endif,
      do_extras(extras),
      for k from 1 to nfun do
        hs :=       number2string(first(plotspecs[k,1]))
             //" "//number2string(second(plotspecs[k,1]))
             //" "//number2string(third(plotspecs[k,1]))//" setrgbcolor\n"
             //if numberq(plotspecs[k,2]) then
                 number2string(
                   roundn(scalenumber(plotspecs[k,2]),scaledecplaces))
               else
                 plotspecs[k,2]
               endif//" setlinewidth\n",
        if stringq(plotspecs[k,4]) then
          hs := hs//plotspecs[k,4]//" setdash\n"
        else
          hs:=hs//"[",
          d := plotspecs[k,4],
          while not nullq(d) do
            if numberq(first(d)) then
              hs:=hs//" "
                 //number2string(roundn(scalenumber(first(d)),scaledecplaces)),
              d := rest(d),
              if nullq(d) then
                hs := hs//" ] 0 setdash\n"
              endif
            else
              hs := hs//" ] ",
              if not nullq(rest(d)) and numberq(second(d)) then
                 hs := hs//number2string
                           (roundn(scalenumber(second(d)),scaledecplaces))
                            //" setdash\n"
              else
                hs := hs//" 0 setdash\n"
              endif,
              d := {}
            endif
          endwhile
        endif,
        display(out,hs),  
        plotspecs[k,1] := hs,
        nsub := third(plotspecs[k,rowlenplotspecs]),
        if plotspecs[k,5] = 'parametric then xy00 := ct2s(0,0) endif,
        if plotspecs[k,5] = 'invalid then 
          plotspecs[k,3] := 'invalid 
        else
          cvalues := values[k]
        endif,
        if plotspecs[k,5] === 'bars then plotspecs[k,3] := 'bars endif,
        if plotspecs[k,3] === 'line then
          displayln(out,"newpath ",ct2s(cvalues[0,1],cvalues[0,2]),
                                                                 " moveto"),
          for i from 1 to nsub do
            displayln(out,ct2s(cvalues[i,1],cvalues[i,2])," lineto")
          endfor,
          displayln(out,"stroke")
        elseif plotspecs[k,3] in {'sq,'tri,'circ,'invisible} then
          symstring :=
          case plotspecs[k,3]
            of tri,  trisym(plotspecs[k,7],scalenumber)
            of sq,   squaresym(plotspecs[k,7],scalenumber)
            of circ, circlesym(plotspecs[k,7],scalenumber)
            of invisible, invisiblesym(0,0)
            else displayln("Invalid drawing symbol, \'sq used instead."),
                 squaresym(plotspecs[k,7],scalenumber)
          endcase,
          for i from 0 to nsub do
            displayln(out,"newpath ",ct2s(cvalues[i,1],cvalues[i,2]),
             " moveto\n",symstring,"\nstroke")
          endfor,
          plotspecs[k,1] := list(plotspecs[k,1],symstring)
        elseif plotspecs[k,3] === 'imp then
          if plotspecs[k,5] === 'parametric then
            for i from 0 to nsub do
              displayln(out,"newpath ",xy00," moveto ",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto stroke")
            endfor 
          else
            for i from 0 to nsub do
              displayln(out,"newpath ",ct2s(cvalues[i,1],0)," moveto ",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto stroke")
            endfor
          endif
        elseif plotspecs[k,3] === 'fill then
          if plotspecs[k,5] === 'parametric then
            for i from 1 to nsub do
              displayln(out,"newpath ",
               xy00," moveto\n",
               ct2s(cvalues[i-1,1],cvalues[i-1,2])," lineto\n",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto\n",
               " closepath fill")
            endfor
          else
            for i from 1 to nsub do
              displayln(out,"newpath ",
               ct2s(cvalues[i-1,1],0)," moveto\n",
               ct2s(cvalues[i-1,1],cvalues[i-1,2])," lineto\n",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto\n",
               ct2s(cvalues[i,1],0)," lineto\n",
               " closepath fill")
            endfor
          endif
        elseif plotspecs[k,3] === 'clos then
          if plotspecs[k,5] === 'parametric then
            for i from 1 to nsub do
              displayln(out,"newpath ",
               xy00," moveto\n",
               ct2s(cvalues[i-1,1],cvalues[i-1,2])," lineto\n",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto\n",
               " closepath stroke")
            endfor
          else
            for i from 1 to nsub do
              displayln(out,"newpath ",
               ct2s(cvalues[i-1,1],0)," moveto\n",
               ct2s(cvalues[i-1,1],cvalues[i-1,2])," lineto\n",
               ct2s(cvalues[i,1],cvalues[i,2])," lineto\n",
                 ct2s(cvalues[i,1],0)," lineto\n",
               "closepath stroke")
            endfor
          endif
        elseif plotspecs[k,3] === 'bars then
          bw := first(cvalues),
          barshift:=second(cvalues),
          tarray := third(cvalues),
          lowi := lowindex(tarray,1),
          highi := highindex(tarray,1),
          for i from lowi to highi do
            x := tarray[i,1],
            y := tarray[i,2],
            displayln(out,"newpath ",
                          ct2s(x-bw*0.5+barshift,0)," moveto\n",
                          ct2s(x-bw*0.5+barshift,y)," lineto\n",
                          ct2s(x+bw*0.5+barshift,y)," lineto\n",
                          ct2s(x+bw*0.5+barshift,0)," lineto\n",
                          "closepath fill")
          endfor,
          if drawbarframes then
            displayln(out,defaultframelinecolor," setrgbcolor ",
                          defaultframelinewidth," setlinewidth ",
                          defaultframelinedashing," setdash"),
            for i from lowi to highi do
              x := tarray[i,1],
              y := tarray[i,2],
              displayln(out,"newpath ",
                            ct2s(x-bw*0.5+barshift,0)," moveto\n",
                            ct2s(x-bw*0.5+barshift,y)," lineto\n",
                            ct2s(x+bw*0.5+barshift,y)," lineto\n",
                            ct2s(x+bw*0.5+barshift,0)," lineto\n",
                            "closepath stroke")
            endfor
          endif
        else
          displayln(
            "Invalid function type or invalid drawing type for function ",k,
                                           ";\nfunction ",k," not drawn.")
        endif
      endfor,
      if legendshift > 0 then
        xp := 0,
        yp := 0,
        displayln(out,"%\n%legend\n%"),
        displayln(out,"/",legendtextfont," findfont ",legendtextsize,
                                                   " scalefont setfont"),
        displayln(out,"newpath ",ct2s(minx,miny),
                              " moveto 2 -25 rmoveto currentpoint"),
        for k from 1 to nfun do
          if stringq(plotspecs[k,6]) then
            if legendspec and 
                (length(legendspec) < 3
                 or not numberq(xp : pop legendspec)
                 or not numberq(yp : pop legendspec) ) then
                displayln("Too few legend places.")
            endif,
            if listq(plotspecs[k,1]) then
              display(out,first(plotspecs[k,1])),
              if legendspec then
                displayln(out,
                    "pop pop newpath ",xp," ",yp," moveto 10 0 rmoveto ",
                    "currentpoint\n",second(plotspecs[k,1])," stroke moveto ",
                    "10 0 rmoveto currentpoint newpath moveto 4 -4 rmoveto")
              else
                displayln(out,"newpath moveto 10 0 rmoveto currentpoint\n",
                     second(plotspecs[k,1])," stroke","\nmoveto 10 0 rmoveto ",
                     "currentpoint newpath moveto 4 -4 rmoveto")
              endif 
            else
              display(out,plotspecs[k,1]),
              if legendspec then
                displayln(out,
                  "pop pop newpath ",xp," ",yp,
                  " moveto 20 0 rlineto currentpoint stroke\n",
                  "newpath moveto 4 -4 rmoveto")
              else
                displayln(out,
                  "newpath moveto 20 0 rlineto currentpoint stroke",
                  " newpath moveto 4 -4 rmoveto")
              endif
            endif,
            displayln(out,"0 0 0 setrgbcolor\n(",
                      plotspecs[k,6],") show\n10 4 rmoveto currentpoint")
          endif
        endfor,
        displayln(out,"pop pop")
      endif,
      if not plottitle = "" then
        displayln(out,"0.0 0.0 0.0 setrgbcolor"),
        displayln(out,titlefontspec),
        displayln(out,"newpath ",xabsshift," ",yabsshift-12," moveto"),
        displayln(out,"(",plottitle,") show"),
        fontlist := cons(titlefont,fontlist)
      endif,
      displayln(out,"%%Trailer"),
      if not nullq(fontlist) then
        fontlist := dropmulti(quicksort(fontlist,stringltq)),
        display(out,"%%DocumentFonts:"),
        repeat
          display(out," ",first(fontlist))
        until
          nullq(fontlist : rest(fontlist))
        endrepeat,
        displayln(out,"")
      endif,
      displayln(out,"%%EOF"),
      closeout(out),
      {minx,miny,maxx,maxy}  *** plot4 returns the effective funrange
    endwith
  endif
endwith;

plot(f,+r) ::
case length(r)
  of 0, plot4(f,#f,#f,#f)
  of 1, plot4(f,first(r),#f,#f)
  of 2, plot4(f,first(r),second(r),#f)
  of 3, plot4(f,first(r),second(r),third(r))
 else  "Invalid number of arguments (1 to 4 are allowed)."
endcase;

xplot(f,+r) ::
with
  res :: case length(r)
           of 0, plot4(f,#f,#f,#f)
           of 1, plot4(f,first(r),#f,#f)
           of 2, plot4(f,first(r),second(r),#f)
           of 3, plot4(f,first(r),second(r),third(r))
          else  "Invalid number of arguments (1 to 4 are allowed)."
         endcase
do
  if listq res and not nullq res then viewplot() endif, 
  res 
endwith;

arrow(x1,y1,x2,y2,toplen,topwidth)::
with
  len::sqrt((x2-x1)^2+(y2-y1)^2),
  a::#f,
  xdir::#f,
  ydir::#f
do
  if len < 0.1 then
    displayln("arrow error: length is ",len,"; ist must be at least 0.1")
  else
    a:=atan2(y2-y1,x2-x1),
    xdir:=(x2-x1)/len,
    ydir:=(y2-y1)/len,
***    displayln("len is ",len,". Angle is ",a,"=",roundn(a*180/pi,2)," deg."),
    {'ps,
       "newpath",x1,y1,"moveto",x2,y2,"lineto",
       x2-toplen*xdir-ydir*topwidth/2,y2-toplen*ydir+xdir*topwidth/2,
       "moveto",
       x2,y2,"lineto",
       x2-toplen*xdir+ydir*topwidth/2,y2-toplen*ydir-xdir*topwidth/2,
       "lineto stroke"
    }
  endif
endwith;

pline(x1,y1,x2,y2,+r)::
with
  fp::{'ps,"newpath",x1,y1,"moveto",x2,y2,"lineto"},
  fr::{},
  x::#f,
  y::#f
do
  while((x:pop r) and (y:pop r)) do
    push(x,fr),
    push(y,fr),
    push("lineto",fr) 
  endwhile,
  push("stroke",fr),
  append(fp,reverse fr)
endwith;

cline(x1,y1,x2,y2,x3,y3,+r)::
with
  fp::{'ps,"newpath",x1,y1,"moveto",x2,y2,"lineto",x3,y3,"lineto"},
  fr::{},
  x::#f,
  y::#f
do
  while((x:pop r) and (y:pop r)) do
    push(x,fr),
    push(y,fr),
    push("lineto",fr) 
  endwhile,
  push("closepath stroke",fr),
  append(fp,reverse fr)
endwith;

sketchframe(xw,yw)::
{'ps,"gsave 1 0 1 setrgbcolor 0.3 setlinewidth",
"newpath",0,0,"moveto",xw,0,"lineto",xw,yw,"lineto",0,yw,"lineto",
"closepath stroke"};

rectangle(xmin,ymin,xmax,ymax)::
{'ps,
"newpath",xmin,ymin,"moveto",xmax,ymin,"lineto",
xmax,ymax,"lineto",xmin,ymax,"lineto",
"closepath stroke"};

cir(x,y,r)::
{'ps,"newpath",x+r,y,"moveto",x,y,{'scale, r},"0","370","arc stroke"};

squ(x,y,a)::cline(x-a/2,y-a/2,x+a/2,y-a/2,x+a/2,y+a/2,x-a/2,y+a/2);

curve1(tx1,ty1,x1,y1,x2,y2,tx2,ty2)::
  {'ps,"newpath",x1,y1,"moveto",tx1,ty1,tx2,ty2,x2,y2,"curveto stroke"};

curvec(x1,y1,x2,y2,x3,y3,+r)::
with
  rs::append({x1,y1,x2,y2,x3,y3},r),
  rr::reverse(rs),
  n::length(rs),
  l::{"moveto\n",y1,x1,"newpath",'ps},
  tx::#f,
  ty::#f,
  s1::#f,t1::#f,s2::#f,t2::#f,s3::#f,t3::#f,s4::#f,t4::#f,
  rcheck::#f
do
if (n mod 2)=1 then
  displayln("curvec error: number of arguments must be even"),
  {'Invalid}
else
  rs:=append(append({second(rr),first(rr)},rs),{x1,y1,x2,y2}),
  n:=n/2,
  rcheck:=rs,
  for k from 1 to n do
    s1:=pop(rs),
    t1:=pop(rs),
    s2:=first(rs),
    t2:=second(rs),
    s3:=third(rs),
    t3:=fourth(rs),
    s4:=third(restofrest(rs)),
    t4:=fourth(restofrest(rs)),
    push(s2+(s3-s1)/4,l),
    push(t2+(t3-t1)/4,l),
    push(s3+(s2-s4)/4,l),
    push(t3+(t2-t4)/4,l),
    push(s3,l),
    push(t3,l),
    push("curveto\n",l)
  endfor,
  push("stroke\n",l),
  reverse(l)
endif
endwith;  

fcurvec(ang,fill,space,x1,y1,x2,y2,x3,y3,+r)::
with
  rs::append({x1,y1,x2,y2,x3,y3},r),
  rr::reverse(rs),
  n::length(rs),
  l::{"moveto\n",y1,x1,"newpath",'ps},
  wx::#f,
  wy::#f,
  R::#f,mpx::#f,mpy::#f,
  s1::#f,t1::#f,s2::#f,t2::#f,s3::#f,t3::#f,s4::#f,t4::#f,
  rcheck::#f,
  minx::x1,maxx::x1,miny::y1,maxy::y1
do
if (n mod 2)=1 then
  displayln("curvec error: number of arguments must be even"),
  {'Invalid}
else
  rs:=append(append({second(rr),first(rr)},rs),{x1,y1,x2,y2}),
  n:=n/2,
  rcheck:=rs,
  for k from 1 to n do
    s1:=pop(rs),
    t1:=pop(rs),
    minx:=min(s1,minx),
    maxx:=max(s1,maxx),
    miny:=min(t1,miny),
    maxy:=max(t1,maxy),
    s2:=first(rs),
    t2:=second(rs),
    s3:=third(rs),
    t3:=fourth(rs),
    s4:=third(restofrest(rs)),
    t4:=fourth(restofrest(rs)),
    push(s2+(s3-s1)/4,l),
    push(t2+(t3-t1)/4,l),
    push(s3+(s2-s4)/4,l),
    push(t3+(t2-t4)/4,l),
    push(s3,l),
    push(t3,l),
    push("curveto\n",l)
  endfor,
  wx:=maxx-minx,
  wy:=maxy-miny,
  mpx:=minx+wx/2,
  mpy:=miny+wy/2,
  minx:=minx-wx/4-0.1,
  maxx:=maxx+wx/4+0.1,
  miny:=miny-wy/4-0.1,
  maxy:=maxy+wx/4+0.1,
  R:=sqrt(wx^2+wy^2)*0.6+0.1,
  ang:=(ang-90)*pi/180,
  push("gsave clip newpath",l),
  push({'scale,2*R},l),
  push("setlinewidth",l),
  push("[",l),
  push({'scale,fill},l),
  push({'scale,space},l),
  push("] 0 setdash",l),
  push(roundn(mpx+R*cos(ang),3),l), 
  push(roundn(mpy+R*sin(ang),3),l),
  push("moveto",l),
  push(roundn(mpx-R*cos(ang),3),l), 
  push(roundn(mpy-R*sin(ang),3),l),
  push("lineto stroke grestore stroke\n",l),
  reverse(l)
endif
endwith;

flattengraphicslist(l)::
if not listq(l) or nullq(l) or not listq(first(l)) then
  l
elseif nullq(first(l)) then
  flattengraphicslist(rest(l))
elseif symbolq(first(first(l))) then
  cons(first(l),flattengraphicslist(rest(l)))
else
  append(flattengraphicslist(first(l)),flattengraphicslist(rest(l)))
endif;

move(x,y,l)::
with
  moved::{},
  a::#f,
  b::#f 
do
if listq(l) and symbolq(first(l)) then
  push(pop(l),moved),
  while not nullq(l) do
    a:=pop(l),
    if numberq(a) and not nullq(l) and numberq(first(l)) then
      b:=pop(l),
      push(a+x,moved),
      push(b+y,moved)
    else
      push(a,moved)
    endif
  endwhile,
  reverse(moved)
else
  l
endif
endwith;


xsketch(xw,yw,extra1,+extra)::
begin
if xw<.1 or yw<.1 then
  "Invalid xmax or ymax; first and second argument must be > 0.1"
elseif not extra1 or extra1={} or extra1 = 0 then
  "No plot elementes, or invalid first plot element."
else
  xplot(
  {
    {t->0,{'ra,0,xw/1000,xw/2000},       {'dr,'invisible}},
    {t->yw,{'ra,xw-xw/1000,xw,xw/2000},  {'dr,'invisible}}
  },
  #f,
  {'default,'auto,'nocoords},
  flattengraphicslist(
    if nullq extra and listq extra1 and listq (first extra1) then
      extra1
    else
      cons(extra1,extra)
    endif
  )
)
endif
end;

sket(xw,yw,extra)::
if xw<.1 or yw<.1 then
  "Invalid xmax or ymax; first and second argument must be > 0.1"
elseif not extra or extra={} or extra = 0 then
  "No plot elementes, or invalid first plot element."
else
  plot(
  {
    {t->0,{'ra,0,xw/1000,xw/2000},       {'dr,'invisible}},
    {t->yw,{'ra,xw-xw/1000,xw,xw/2000},  {'dr,'invisible}}
  },
  #f,
  {'default,'auto,'nocoords},
  extra) 
endif;

xsket(xw,yw,extra)::
with res :: sket(xw,yw,extra) do
  if listq res and not nullq res then viewplot() endif
endwith;


sketch(xw,yw,extra1,+extra)::
begin
if xw<.1 or yw<.1 then
  "Invalid xmax or ymax; first and second argument must be > 0.1"
elseif not extra1 or extra1={} or extra1 = 0 then
  "No plot elementes, or invalid first plot element."
else
  plot(
  {
    {t->0,{'ra,0,xw/1000,xw/2000},       {'dr,'invisible}},
    {t->yw,{'ra,xw-xw/1000,xw,xw/2000},  {'dr,'invisible}}
  },
  #f,
  {'default,'auto,'nocoords},
  flattengraphicslist(
    if nullq extra and listq extra1 and listq (first extra1) then
      extra1
    else
      cons(extra1,extra)
    endif
  )
)
endif
end;

displayln("\nModule \"plot\" (Version ",plot_version,", ",plot_date,")");
