begin
display("This is the module \"test_plot\".\n",
   "Version and date of this test module:"), 
  test_plot_version::"0.02", 
  test_plot_date::"19.12.1999",
  displayln(test_plot_version,"  ",test_plot_date)
end;
displayln("\nScheme system is ",$scheme_system);
displayln("\n*** Testing procedures in module \"plot\" ***\n",
          "Version and date of tested module \"plot\": ",
          plot_version," ",plot_date);

*** Example 1

documenttitle :="Example 1";
displayln("*** Example 1 ***");
plot(sin,{0,4*pi},{'a4w,'auto});
saveplot("plot_example_1.eps");
 
*** Example 2
documenttitle :="Example 2";
displayln("*** Example 2 ***");
plot(sin,{0,4*pi},'a4w);
saveplot("plot_example_2.eps");

*** Example 3
documenttitle :="Example 3";
displayln("*** Example 3 ***");
plot(sin,{0,4*pi},{'a4w,{'title,"The sine function"}});
saveplot("plot_example_3.eps");

*** Example 4
documenttitle :="Example 4";
displayln("*** Example 4 ***");
plot({sin,{'wi,"3"},{'da,"5 2"},{'rg,0,0.6,0.6}},{0,4*pi},{'a4w,'nocoords});
saveplot("plot_example_4.eps");

*** Example 5
documenttitle :="Example 5";
displayln("*** Example 5 ***");
plot({{sin,{'dr,'fill}},{cos,{'dr,'imp}},{x->- sin(x),{'dr,'clos}},
      {x->-cos x}},{0,10});
saveplot("plot_example_5.eps");

*** Example 6 
documenttitle :="Example 6";
displayln("*** Example 6 ***");
plot({{"f(x) = sin(x)",{'dr,'fill}},{"f(x) = cos(x)",{'dr,'imp}},
{"f(x) = - sin(x)",{'dr,'clos}},{"f(x) = -cos(x)"}},{0,10});
saveplot("plot_example_6.eps");

*** Example 7
documenttitle :="Example 7";
displayln("*** Example 7 ***");
plot({{sin,{'ra,pi/2,3/2*pi}},{cos,{'ra,0,5,0.5}},
{"f(x) = - sin(x)",{'ra,2,8,0.05}},{"f(x) = -cos(x)"}},{0,10});
saveplot("plot_example_7.eps");

*** Example 8
documenttitle :="Example 8";
displayln("*** Example 8 ***");
plot({ {x->{0.3*x*cos(x),0.3*x*sin(x)}},
       {x->{0.2*x*cos(x),0.4*x*sin(x)},{'dr,'sq}}},
       {0,6*pi,0.05},'auto);
saveplot("plot_example_8.eps");

*** Example 9
documenttitle :="Example 9";
displayln("*** Example 9 ***");
s :: makematrix({{ 1,4},{3,9},{3.4,5},{2.8,7.1},{1.7,6.3},{4.3,4.9},
{ 1.3,4.5},{2.3,3.9},{3.4,5,05},{4.8,2.1},{3.7,4.3},{2.3,6.9}});
plot({s,{'dr,'tri},{'si,"6"},{'leg,"The scatter variable"}});
saveplot("plot_example_9.eps");

*** Example 10
documenttitle :="Example 10";
displayln("*** Example 10 ***");
s :: makematrix({{ 1,4},{3,9},{3.4,5},{2.8,7.1},{1.7,6.3},{4.3,4.9},
{ 1.3,4.5},{2.3,3.9},{3.4,5,05},{4.8,2.1},{3.7,4.3},{2.3,6.9}});
t :: makematrix({{ 1+pi,4.3},{3.3,7.9},{2.4,5.2},{3.8,7.3},{1.7,5.3},{3.6,4.9},
{ sqrt(2),4.5},{3.3,4.9},{3.6,5,25},{3.8,2.5},{1.7,4.3},{3.3,6.9}});
plot({{s,{'dr,'tri},{'si,"6"},{'leg,"The scatter variable"}},
{t,{'dr,'circ},{'si,"8"}},{x->0.3*x*x}},
{2,5});
saveplot("plot_example_10.eps");

*** Example 11
documenttitle :="Example 11";
displayln("*** Example 11 ***");
b1 :: makematrix({{ 1,4},{3,9},{5,5},{7,7.1},{9,6.3},{11,4.9}});
b2 :: makematrix({{1,4.5},{3,3.9},{5,5.05},{7,2.1},{9,4.3},{11,6.9}});
b3 :: makematrix({{ 1,4.3},{3,7.9},{5,5.2},{7,7.3},{9,5.3},{11,4.9}});
plot({{{'bars,0.3,-0.4,b1},{'wi,"6"},{'leg,"The Red"}},
      {{'bars,0.3,0,b2},{'wi,"6"},{'leg,"The Green"}},
      {{'bars,0.3,0.4,b3},{'wi,"6"},{'leg,"The Blue"}},
      {x->2*sin(x)+4,{'wi,0.2}}},
       {0,12});
saveplot("plot_example_11.eps");

*** Example 12
documenttitle :="Example 12";
displayln("*** Example 12 ***");
b1 :: makematrix({{ 1,4},{3,9},{5,5},{7,7.1},{9,6.3},{11,4.9}});
b2 :: makematrix(
 {{1,4.5,"One"},{3,3.9,"Three"},{5,5.05,"Fife"},{7,2.1,"Seven"},
                  {9,4.3,"Nine"},{11,6.9,"Eleven"}});
b3 :: makematrix({{ 1,4.3},{3,7.9},{5,5.2},{7,7.3},{9,5.3},{11,4.9}});
plot({{{'bars,0.3,-0.4,b1},{'wi,"6"},{'leg,"The Red"}},
      {{'bars,0.3,0,b2},{'wi,"6"},{'leg,"The Green"}},
      {{'bars,0.3,0.4,b3},{'wi,"6"},{'leg,"The Blue"}},
      {x->2*sin(x)+4,{'wi,0.2}}},
       {0,12},{'default,'noxcoords});
saveplot("plot_example_12.eps");

*** Example 13
documenttitle :="Example 13";
displayln("*** Example 13 ***");
plot(sin,{0,2*pi},'default,
{{'li,"60 50","200 100"},{'rg,0,0,1},{'li,pi/2,1,3*pi/2,-1},
{'fo,"Times-Bold","36"},{'te,"The blue line",2.2,0.6,-30}});
saveplot("plot_example_13.eps");

*** Example 14
documenttitle :="Example 14";
displayln("*** Example 14 ***");
ang :: atan(-2/pi)*180/pi;
plot(sin,{0,2*pi},{'default,'auto},    
{{'li,"60 50","200 100"},{'rg,0,0,1},{'li,pi/2,1,3*pi/2,-1},
{'fo,"Times-Bold","36"},{'te,"The blue line",2.2,0.6,ang}});
saveplot("plot_example_14.eps");

displayln("\nModule \"test_plot\" (Version ",test_plot_version,", ",
                                     test_plot_date,")");
