(define $matrices_version "0.02") (define $matrices_date "30.09.1999") 
(define $matrixq (lambda ($a) (if (and (eslarray? $a) (equal? (arraydim $a) 2)) (cdr (eslarray? $a)) #f))) 
(define $zerorow (lambda ($n) (if (or (not (integer? $n)) (< $n 1)) (begin (dispmoreln "zerovector: invalid argument" $n) 0) (let (($zr (makearray 1 1 1 $n))) (begin (let* (($$_2 1) ($$_3 $n) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $zr 0 1 $j)))))) $zr)))) 
(define $makerow (lambda ($l) (if (or (not (list $l)) (equal? (length $l) 0)) (begin (dispmoreln "makerow: argument must be list of length at least 1.") 0) (let (($zr (makearray 1 1 1 (length $l)))) (begin (let* (($$_2 1) ($$_3 (length $l)) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $zr (list-ref $l (- $j 1)) 1 $j)))))) $zr)))) 
(define $makevector (lambda ($l) (if (or (not (list $l)) (equal? (length $l) 0)) (begin (dispmoreln "makevector: argument must be list of length at least 1.") 0) (let (($vec (makearray 1 (length $l)))) (begin (let* (($$_2 1) ($$_3 (length $l)) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $vec (list-ref $l (- $j 1)) $j)))))) $vec)))) 
(define $vec2col (lambda ($l) (if (not (and (eslarray? $l) (equal? (arraydim $l) 1) (equal? (lowindex $l 1) 1))) (begin (dispmoreln "vec2col: argument must be an array of dim 1 and low index 1.") #f) (let* (($n (highindex $l 1)) ($col (makearray 1 $n 1 1))) (begin (let* (($$_2 1) ($$_3 $n) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($i $$_2 (+ $i $$_4))) (($$_0 $i $$_3) $$_1) (set! $$_1 (setarrayval! $col (arrayval $l $i) $i 1)))))) $col)))) 
(define $col2vec (lambda ($l) (if (not (and ($matrixq $l) (equal? (lowindex $l 1) 1) (equal? (lowindex $l 2) 1) (equal? (highindex $l 2) 1))) (begin (dispmoreln "col2vec: argument must be a column matrix.") #f) (let* (($n (highindex $l 1)) ($vec (makearray 1 $n))) (begin (let* (($$_2 1) ($$_3 $n) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($i $$_2 (+ $i $$_4))) (($$_0 $i $$_3) $$_1) (set! $$_1 (setarrayval! $vec (arrayval $l $i 1) $i)))))) $vec)))) 
(define $checklistoflists (lambda ($l) (cond ((or (not (list $l)) (equal? (length $l) 0)) (dispmoreln "checklistoflists: argument must be list of length at least 1.") #f) ((or (not (list (car $l))) (equal? (length (car $l)) 0)) (dispmoreln "checklistoflists: Each element of the argument must be a list" "of length at least 1.") #f) (else (let* (($n (length $l)) ($m (length (car $l))) ($ismatrix #t) ($line $l)) (let (($$_1 #f)) (do () ((not (and (not (null? $line)) $ismatrix)) $$_1) (set! $$_1 (begin (begin (set! $ismatrix (equal? (length (car $l)) $m)) $ismatrix) (begin (set! $line (cdr $line)) $line))))) (if $ismatrix (list $n $m) #f)))))) 
(define $makematrix (lambda ($l) (if (not ($checklistoflists $l)) (begin (dispmoreln "makematrix: argument must be list of length at least 1," "elements of this list
" "must be lists, all of the same length of at least 1.") #f) (let* (($n (length $l)) ($m (length (car $l))) ($mat (makearray 1 $n 1 $m))) (begin (let* (($$_2 1) ($$_3 $n) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($i $$_2 (+ $i $$_4))) (($$_0 $i $$_3) $$_1) (set! $$_1 (begin (let* (($$_2 1) ($$_3 $m) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $mat (list-ref (list-ref $l (- $i 1)) (- $j 1)) $i $j))))))))))) $mat)))) 
(define $makecol (lambda ($l) (if (or (not (list $l)) (equal? (length $l) 0)) (begin (dispmoreln "makecol: argument must be list of length at least 1.") 0) (let (($zc (makearray 1 (length $l) 1 1))) (begin (let* (($$_2 1) ($$_3 (length $l)) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $zc (list-ref $l (- $j 1)) $j 1)))))) $zc)))) 
(define $zerocol (lambda ($n) (if (or (not (integer? $n)) (< $n 1)) (begin (dispmoreln "zerovector: invalid argument" $n) 0) (let (($zc (makearray 1 $n 1 1))) (begin (let* (($$_2 1) ($$_3 $n) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (setarrayval! $zc 0 $j 1)))))) $zc)))) 
(define $matcopy (lambda ($a) (if (not ($matrixq $a)) (begin (dispmoreln "matcopy: a is not a matrix") (list)) (let* (($rl (lowindex $a 1)) ($ru (highindex $a 1)) ($cl (lowindex $a 2)) ($cu (highindex $a 2)) ($s (makearray $rl $ru $cl $cu))) (begin (let* (($$_2 $rl) ($$_3 $ru) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($r $$_2 (+ $r $$_4))) (($$_0 $r $$_3) $$_1) (set! $$_1 (begin (let* (($$_2 $cl) ($$_3 $cu) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($c $$_2 (+ $c $$_4))) (($$_0 $c $$_3) $$_1) (set! $$_1 (setarrayval! $s (arrayval $a $r $c) $r $c))))))))))) (set-car! (cddr $s) (caddr $a)) $s)))) 
(define $matdisplay (lambda ($a) (if (not ($matrixq $a)) (begin (dispmoreln "matdisplay: argument is not a matrix") (list)) (begin (dispmoreln "The matrix has lines from " (lowindex $a 1) " to " (highindex $a 1) " and columns from " (lowindex $a 2) " to " (highindex $a 2) ".") (begin (let* (($$_2 (lowindex $a 1)) ($$_3 (highindex $a 1)) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($i $$_2 (+ $i $$_4))) (($$_0 $i $$_3) $$_1) (set! $$_1 (begin (dispmore "line" (if (< $i 10) " " "") $i ":  ") (begin (let* (($$_2 (lowindex $a 2)) ($$_3 (highindex $a 2)) ($$_4 1) ($$_0 (if (> $$_4 0) > <)) ($$_1 0)) (if (or (< (* (- $$_3 $$_2) $$_4) 0) (equal? $$_4 0) (equal? $$_4 0.0)) (forerror $$_2 $$_3 $$_4) (do (($j $$_2 (+ $j $$_4))) (($$_0 $j $$_3) $$_1) (set! $$_1 (dispmore (arrayval $a $i $j) " ")))))) (dispmoreln))))))) (list))))) 
(dispmoreln "Module \"matrices\" (Version " $matrices_version ", " $matrices_date ")") 
